name: Build & Staging
on:
  push:
    branches:
      - master

env:
  CONTAINER_REGISTRY: ghcr.io
  CONTAINER_REGISTRY_USER: ${{ secrets.GHCR_CONTAINER_REGISTRY_USER }}
  CONTAINER_REGISTRY_PASSWORD: ${{ secrets.GHCR_TOKEN }}
  CONTAINER_REGISTRY_REPO: ghcr.io/city-of-helsinki/${{ github.event.repository.name }}
  REPO_NAME: ${{ github.event.repository.name }}
  KUBECONFIG_RAW: ${{ secrets.KUBECONFIG_RAW_STAGING }}
  BUILD_ARTIFACT_FOLDER: "build_artifacts"
  SERVICE_ARTIFACT_FOLDER: "service_artifacts"
  APP_MIGRATE_COMMAND: /app/.prod/on_deploy.sh
  K8S_REQUEST_CPU: 100m
  K8S_REQUEST_RAM: 300Mi
  K8S_LIMIT_CPU: 300m
  K8S_LIMIT_RAM: 400Mi
  K8S_REPLICACOUNT: 2

jobs:
  build:
    runs-on: ubuntu-latest
    name: Build
    steps:
      - uses: actions/checkout@v2
      - name: Build
        uses: andersinno/kolga-build-action@v2

  staging:
    runs-on: ubuntu-latest
    needs: build
    name: Staging
    steps:
      - uses: actions/checkout@v2
      - uses: andersinno/kolga-setup-action@v2

      - name: Deploy
        uses: andersinno/kolga-deploy-action@v2
        with:
          track: 'staging'
        env:
          K8S_NAMESPACE: ${{ secrets.K8S_NAMESPACE_STAGING }}
          ENVIRONMENT_URL: https://${{ secrets.ENVIRONMENT_URL_STAGING }}
          K8S_SECRET_TIER: "stage"
          K8S_SECRET_SKIP_DATABASE_CHECK: 1
          K8S_SECRET_ALLOWED_HOSTS: "*"
          K8S_SECRET_CORS_ORIGIN_ALLOW_ALL: 1
          K8S_SECRET_SECRET_KEY: ${{ secrets.GH_QA_DJANGO_SECRET_KEY }}
          K8S_SECRET_TOKEN_AUTH_AUTHSERVER_URL: "https://tunnistamo.test.kuva.hel.ninja/openid"
          K8S_SECRET_MAIL_MAILGUN_KEY: ${{ secrets.GH_QA_SECRET_MAILGUN_API_KEY }}
          K8S_SECRET_MAIL_MAILGUN_DOMAIN: "mail.hel.ninja"
          K8S_SECRET_MAIL_MAILGUN_API: "https://api.eu.mailgun.net/v3"
          K8S_SECRET_MAILER_EMAIL_BACKEND: "anymail.backends.mailgun.EmailBackend"
          K8S_SECRET_DEFAULT_FROM_EMAIL: "venepaikkavaraukset-testi@hel.ninja"
          K8S_SECRET_NOTIFICATIONS_ENABLED: "true"
          K8S_SECRET_SENTRY_DSN: ${{ secrets.GH_QA_SENTRY_DSN }}
          K8S_SECRET_SENTRY_ENVIRONMENT: "staging"
          K8S_SECRET_VENE_UI_RETURN_URL: 'https://venepaikka.test.kuva.hel.ninja/{LANG}'
          K8S_SECRET_VENE_UI_URL: "https://venepaikka.test.kuva.hel.ninja"
          K8S_SECRET_VENE_PAYMENTS_BAMBORA_API_URL: ${{ secrets.GH_QA_BAMBORA_API_URL }}
          K8S_SECRET_VENE_PAYMENTS_BAMBORA_API_KEY: ${{ secrets.GH_QA_BAMBORA_API_KEY }}
          K8S_SECRET_VENE_PAYMENTS_BAMBORA_API_SECRET: ${{ secrets.GH_QA_BAMBORA_API_SECRET }}
          K8S_SECRET_VENE_PAYMENTS_BAMBORA_PAYMENT_METHODS: ${{ secrets.GH_QA_BAMBORA_PAYMENT_METHODS }}
          K8S_SECRET_PROFILE_API_URL: "https://profiili-api.test.kuva.hel.ninja/graphql/"
          K8S_SECRET_ELASTIC_APM_ENVIRONMENT: "test"
          K8S_SECRET_ELASTIC_APM_SECRET_TOKEN: ${{ secrets.GH_QA_ELASTIC_APM_TOKEN }}
          K8S_SECRET_ELASTIC_APM_SERVER_URL: ${{ secrets.GH_QA_ELASTIC_APM_URL }}
          K8S_SECRET_ELASTIC_APM_SERVICE_NAME: "berths-backend"
          K8S_SECRET_ENABLE_APM_TOOLS: ${{ secrets.GH_QA_ENABLE_APM_TOOLS }}
          K8S_SECRET_VISMASIGN_API_URL: ${{ secrets.GH_TEST_VISMASIGN_API_URL }}
          K8S_SECRET_VISMASIGN_CLIENT_IDENTIFIER: ${{ secrets.GH_TEST_VISMASIGN_CLIENT_IDENTIFIER }}
          K8S_SECRET_VISMASIGN_SECRET: ${{ secrets.GH_TEST_VISMASIGN_SECRET }}
          K8S_SECRET_DATABASE_HOST: ${{ secrets.K8S_SECRET_DATABASE_HOST_STAGING }}
          K8S_SECRET_DATABASE_URL: ${{ secrets.K8S_SECRET_DATABASE_URL_STAGING }}
          K8S_SECRET_DATABASE_PORT: ${{ secrets.K8S_SECRET_DATABASE_PORT_STAGING }}
          K8S_SECRET_DATABASE_DB: ${{ secrets.K8S_SECRET_DATABASE_DB_STAGING }}
          K8S_SECRET_DATABASE_USERNAME: ${{ secrets.K8S_SECRET_DATABASE_USERNAME_STAGING }}
          K8S_SECRET_DATABASE_PASSWORD: ${{ secrets.K8S_SECRET_DATABASE_PASSWORD_STAGING }}
          K8S_SECRET_NOTIFICATION_SERVICE_API_URL: "https://notification-service.test.kuva.hel.ninja/v1"
          K8S_SECRET_NOTIFICATION_SERVICE_SENDER_NAME: "Hel.fi"
          K8S_SECRET_NOTIFICATION_SERVICE_TOKEN: ${{ secrets.GH_QA_SECRET_NOTIFICATION_SERVICE_TOKEN }}

